import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;
/**
 * This actor will represent keys which will allow user progression in dungeons
 * 
 * @author Brendan McSherry
 * @version (May 4/30,2012)
 */
public class Key extends Actor
{
    
    private int moveSpeed = 1;
    public static Key key8;
    
    private GreenfootImage key1 = new GreenfootImage("Key.png");
    public static boolean dead = false;
    public int direction=0;
    public int up=0;
    public int down=0;
    public int left=0;
    public int right=0;
    protected boolean alive;
    protected int xPose;
    protected int yPose;
    
    /**
     * Returns the y position of the key
     */
    public int yPose()
    {
        return yPose;
    }
    
    /**
     * Returns the x position of the key
     */
    public int xPose()
    {
        return xPose;
    }
    
    /**
     * Returns the direction of the key
     */
    public int direction()
    {
        return direction;
    }
    
    /**
     * When called, the key is removed from the world
     */
    public void removeSelf()
    {
        this.getWorld().removeObject(this);
    }
    
    /**
     * When called, sets alive boolean to false, then removes from world
     */
    protected void destroy()
    {
        alive = false;
        removeSelf();
    }
    
    /**
     * Returns whether the key is alive or not
     */
    protected boolean isAlive()
    {
        return this.alive;
    }
    
    
    /**
     * Key constructor
     * @param x,y coordinates to place actor in the world.
     */
    public Key(int x, int y)
    {
        //super(images.length);
        //super.images = this.images;
        //setImages(images[0]);
        
        this.alive = true;
        xPose = x;
        yPose = y;
    }
    
    /**
     * move key for puzzle in specific dungeon room
     */
    public void moveKey(){
        
        
        if(UI.dunVal==8) {
            setImage("Key.png");
                if(direction==0 || direction==4 || direction==8 || direction==12 || direction==16){
                    setLocation(getX(), getY()+1);
                    down++;
                    
                    if(down>80){ direction++; right=0; }
                }
               
               
               if(direction==1 || direction==5 || direction==9 || direction==13 || direction==17){
                   setLocation(getX()+1, getY());
                   right++;
                   
                   if(right>27){ direction++; up=0;}
                }
                
                if(direction==2 || direction==6 || direction==10 || direction==14 || direction==18){
                   setLocation(getX(), getY()-1);
                   up++;
                   Spawner.f8.alive=true; getWorld().addObject(Spawner.f8, 215, 135);
                   Spawner.f8.resetShoot(1); Spawner.f8.stay=1;
                   if(up>80){ direction++; left=0;}
                }
                
                if(direction==3 || direction==7 || direction==11 || direction==15 || direction==19){
                   setLocation(getX()-1, getY());
                   left++;
                   if(left>27){ direction++; down=0;}
                }
               
                if(direction==20)
                {
                    setLocation(getX(), getY()+1);
                    down++;
                    
                    if(down>40){ direction++; right=0;}
                }
                if(direction==21)
                {
                    setLocation(getX()+1, getY());
                    right++;
                    
                    if(right>90){ direction++;}
                }
  
        } else {
        
        }
            
        
        
    }
    
     /**
      * getIt()
      * called when Link picks up key
      */
            public void getIt()
           {
               Actor link = getOneIntersectingObject(Link.class);
               
               if(link != null)
        {
            
            UI.trigger8=1;
            removeSelf();
            UI.secret.play();
            
            if(Spawner.f8.isAlive()==true)Spawner.f8.destroy();
            
            if(UI.trigger9==4 && UI.trigger8==1)
            {
                UI.bossWarp=1;
            }
        }
            }
    
    /**
     * Act method
     */
    public void act() 
    {
        moveKey();
        getIt();
    }    
}
