import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * 
 * 
 * @author Matt Kurupas
 * @version 5/10/2012
 * This class initializes and runs the game.
 * This class creates the world environment and adds the actors to the world
 */
public class LinkWorld  extends World
{
    private static final int WORLD_WIDTH = 252;
    private static final int WORLD_HEIGHT = 219;
    private static final int CELL_SIZE = 1;
    
    public static Link link = new Link();
    public static Heart heart1 = new Heart();
    public static Heart heart2 = new Heart();
    public static Heart heart3 = new Heart();
    public static Heart heart4 = new Heart();
    public static Heart heart5 = new Heart();
    
    public static Spawner spawn = new Spawner();
    /**
     * Constructor for objects of class LinkWorld.
     **/
    public LinkWorld()
    {    
        // Create a new world with 256x219 cells with a cell size of 1x1 pixels.
        super(WORLD_WIDTH, WORLD_HEIGHT, CELL_SIZE);
        UI.horizontalScreen = 0;
        UI.verticalScreen = 0;
        setBackground(UI.tempBg);
        UI.tempBg.drawImage(UI.bar, 0, 0);
        UI.tempBg.drawImage(UI.colorMaskMap[UI.horizontalScreen][UI.verticalScreen], 0, 0);
        UI.tempBg.drawImage(UI.visualMap[UI.horizontalScreen][UI.verticalScreen], 0, 50);       
        
        spawn.getImage().setTransparency(0);
        
        addObject(link, 130, 150);
        
        addObject(new Logo(), 35, 25);
        addObject(new Life(), 205, 16);
        addObject(heart1, 191, 34);
        addObject(heart2, 201, 34);
        addObject(heart3, 211, 34);
        addObject(heart4, 221, 34);
        addObject(heart5, 231, 34);
        addObject(new Buttons(), 128, 25);
        addObject(spawn, 300, 300);
        
        setPaintOrder(Bar.class, Link.class);        
    }//end LinkWorld
    
    /**
     * started()
     * run game
     */
    public void started()
    {
        //UI.tempBg.drawImage(UI.colorMaskMap[UI.horizontalScreen][UI.verticalScreen], 0, 0);
        //UI.tempBg.drawImage(UI.visualMap[UI.horizontalScreen][UI.verticalScreen], 0, 50);
        
        for(int i = 0; i < UI.colorMaskLength-1; i++)
        {
            for(int j = 0; j < UI.colorMaskLength-1; j++)
            {
                UI.colorMaskMap[i][j].setTransparency(0);
            }
        }        
        
        
            UI.music.playLoop();
    
    
    }
    
    public void stopped()
    {
     //   UI.music.stop();
    }
    
}//end class
