import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.Random;
import java.awt.*;

/**
 * Code for Moblin
 * 
 * @author Elizabeth  
 * @version 2/25/12
 */
public class Moblin extends Enemies
{
    //variables
    int direction = 0; //keeps track of direction Moblin is facing
    public static int currentDir = 0;
    int imgRot = 0; //keeps track of degrees of rotation for image
    
    int health = 2; //health of the moblin
    
    private static final int FINAL_DELAY=5;
    private static final int MAX_HURT_TIME=120;
    private int hurtDelay=0;
    private int hurtTimer=0;
    
    /**
     * Act - Holds actions that Moblin will perform each call
     */
    public void act() 
    {
       moveMoblin(); //call to function for random movement
       isHit();
       if(hurt==true){
         while(hurtTimer < MAX_HURT_TIME){
            knockback(direction);
        }
         hurt=false;
         hurtDelay=0;
         hurtTimer=0;
       }
       //healthCheck(); //checks health of Moblin
    } //end act() 

    /**
     * Constructor
     * 
     * Records the x and y location of a newly created Moblin
     */
    public Moblin(int x, int y)
    {
        //super(images.length);
        //super.images = this.images;
        //setImages(images[0]);
        
        this.alive = true;
        xPose = x;
        yPose = y;
    }
    
    /**
     * moveMoblin - Moves Moblin randomly
     */
    public void moveMoblin(){
         Random generator = new Random(); //random number generator
        int ranNum = generator.nextInt(250); //gets random number from 0-249
        //when ranNum 0 rotates Moblin 90 degrees clockwise
        if(ranNum == 0){
            turn(90);
            direction=direction+1;
            currentDir=direction;
            imgRot = imgRot + 90;
            if(direction == 4){ //allows direction to be 0,1,2, or 3 then resets to 0
                direction =0;
                currentDir=0;
                imgRot = 0;
            }
        }
        //when ranNum is 1 rotates Moblin 90 degrees counterclockwise 
        else if(ranNum == 1){
            turn(-90);
            direction=direction-1;
            currentDir=direction;
            imgRot = imgRot - 90;
            if(direction == -1){ //allows direction to be 0,1,2 or 3 then resets to 3
                direction = 3;
                currentDir=3;
                imgRot = 270;
            }
        }
        //when ranNum is >2 moves Moblin according to current direction
        else if(ranNum >= 2){
            //Move Moblin down if he won't hit border
            
            if(UI.dunVal==0 && UI.arenaT!=1) {
                if(direction == 1 && (((LinkWorld) getWorld()).getHeight()-getY())>10 && !UI.colorMaskMap[UI.horizontalScreen][UI.verticalScreen].getColorAt(getX(), getY()+10).equals(Color.black)){
                setImage("MoblinFront0.png"); //loads front facing image
                this.getImage().rotate(270); //rotates image to be oriented correctly
                move(1);
            }
            //Move Moblin left if he won't hit border
            else if(direction == 2 && getX() > 10 && !UI.colorMaskMap[UI.horizontalScreen][UI.verticalScreen].getColorAt(getX()-10, getY()).equals(Color.black)){
                setImage("MoblinLeft0.png"); //loads left facing image
                this.getImage().rotate(imgRot); //rotates image to be oriented correctly
                move(1);
            }
            //Move Moblin up if he won't hit border
            else if(direction == 3 && getY() > 60 && !UI.colorMaskMap[UI.horizontalScreen][UI.verticalScreen].getColorAt(getX(), getY()-10).equals(Color.black)){
                setImage("MoblinBack0.png"); //loads back facing image
                this.getImage().rotate(90); //roates image to be oriented correctly
                move(1); 
            }
            //Move Moblin right if he won't hit border
            else if(direction == 0 && (((LinkWorld) getWorld()).getWidth()-getX())>10 && !UI.colorMaskMap[UI.horizontalScreen][UI.verticalScreen].getColorAt(getX()+10, getY()).equals(Color.black)){
                setImage("MoblinRight0.png"); //loads right facing image
                this.getImage().rotate(imgRot); //rotates image to be oriented correctly
                move(1);
            }
            //Rotate 90 degrees clockwise if current direction will hit border
            else{
                turn(90);
                direction=direction+1;
                currentDir=direction;
                imgRot=imgRot+90;
                if(direction == 4){
                    direction=0;
                    currentDir=0;
                    imgRot=0;
                }
            }  
           
            
        }//end ifDun
         else if(UI.arenaT==1){
             if(direction == 1 && (((LinkWorld) getWorld()).getHeight()-getY())>10 && !UI.arena_mask.getColorAt(getX(), getY()+10).equals(Color.black)){
                 setImage("MoblinFront0.png"); //loads front facing image
                this.getImage().rotate(270); //rotates image to be oriented correctly
                move(1);}
                
             else if(direction == 2 && getX() > 10 && !UI.arena_mask.getColorAt(getX()-10, getY()).equals(Color.black)){
                setImage("MoblinLeft0.png"); //loads left facing image
                this.getImage().rotate(imgRot); //rotates image to be oriented correctly
                move(1);
            }
            
             else if(direction == 3 && getY() > 60 && !UI.arena_mask.getColorAt(getX(), getY()-10).equals(Color.black)){
                setImage("MoblinBack0.png"); //loads back facing image
                this.getImage().rotate(90); //roates image to be oriented correctly
                move(1); 
            }
               else if(direction == 0 && (((LinkWorld) getWorld()).getWidth()-getX())>10 && !UI.arena_mask.getColorAt(getX()+10, getY()).equals(Color.black)){
                setImage("MoblinRight0.png"); //loads right facing image
                this.getImage().rotate(imgRot); //rotates image to be oriented correctly
                move(1);
            }
             else{
                turn(90);
                direction=direction+1;
                imgRot=imgRot+90;
                if(direction == 4){
                    direction=0;
                    imgRot=0;
                }
            }     
            }
            else {
                if(direction == 1 && (((LinkWorld) getWorld()).getHeight()-getY())>10 && !UI.dmasks[UI.dunVal-1].getColorAt(getX(), getY()+10).equals(Color.black)){
                 setImage("MoblinFront0.png"); //loads front facing image
                this.getImage().rotate(270); //rotates image to be oriented correctly
                move(1);}
                
             else if(direction == 2 && getX() > 10 && !UI.dmasks[UI.dunVal-1].getColorAt(getX()-10, getY()).equals(Color.black)){
                setImage("MoblinLeft0.png"); //loads left facing image
                this.getImage().rotate(imgRot); //rotates image to be oriented correctly
                move(1);
            }
            
             else if(direction == 3 && getY() > 60 && !UI.dmasks[UI.dunVal-1].getColorAt(getX(), getY()-10).equals(Color.black)){
                setImage("MoblinBack0.png"); //loads back facing image
                this.getImage().rotate(90); //roates image to be oriented correctly
                move(1); 
            }
               else if(direction == 0 && (((LinkWorld) getWorld()).getWidth()-getX())>10 && !UI.dmasks[UI.dunVal-1].getColorAt(getX()+10, getY()).equals(Color.black)){
                setImage("MoblinRight0.png"); //loads right facing image
                this.getImage().rotate(imgRot); //rotates image to be oriented correctly
                move(1);
            }
             else{
                turn(90);
                direction=direction+1;
                imgRot=imgRot+90;
                if(direction == 4){
                    direction=0;
                    imgRot=0;
                }
            }   
            }
            
            
            }
            
        }
    
    /**
     * Checks if health is equal to zero. If it is, destroys the Moblin.
     */
    private void healthCheck()
    {
        if(health <= 0){
            destroy();
        }
    }//end healthCheck()
    
    /**
     * Knocks the Moblin backwards when hit by Link in the direction of the param
     * @param dir
     *      The direction that the enemy will be knocked back
     */
    public void knockback(int dir){
        if(hurtTimer < MAX_HURT_TIME){    
            if(hurtDelay == FINAL_DELAY){
                if(hurt){
                    switch(dir){
                        case 1:
                        setImage("MoblinHurtFront0.png"); //loads front facing image
                        this.getImage().rotate(270); //rotates image to be oriented correctly
                        break;
                
                        case 2:
                        setImage("MoblinHurtLeft0.png"); //loads left facing image
                        this.getImage().rotate(imgRot); //rotates image to be oriented correctly
                        break;
                        case 3:
                        setImage("MoblinHurtBack0.png"); //loads back facing image
                        this.getImage().rotate(90); //roates image to be oriented correctly
                        break;
                        case 0:
                        setImage("MoblinHurtRight0.png"); //loads right facing image
                        this.getImage().rotate(imgRot); //rotates image to be oriented correctly
                        break;
                    }
                    move(-1);
                    hurt=false;
                }
                else if(!hurt){
                    switch(dir){
                        case 1:
                        setImage("MoblinFront0.png"); //loads front facing image
                        this.getImage().rotate(270); //rotates image to be oriented correctly
                        break;
                
                        case 2:
                        setImage("MoblinLeft0.png"); //loads left facing image
                        this.getImage().rotate(imgRot); //rotates image to be oriented correctly
                        break;
                        case 3:
                        setImage("MoblinBack0.png"); //loads back facing image
                        this.getImage().rotate(90); //roates image to be oriented correctly
                        break;
                        case 0:
                        setImage("MoblinRight0.png"); //loads right facing image
                        this.getImage().rotate(imgRot); //rotates image to be oriented correctly
                        break;
                    }
                    move(-1);
                    hurt=true;
                }
                hurtDelay=0;
            }
            else{
                hurtDelay++;
            }
            hurtTimer++;
        }
    }
    
} //end Moblin class
