import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.Random;
import java.*;
import java.awt.*;
/**
 * Code for Octorock enemy
 * 
 * @author Alex Fielder
 * @version 5/10/2012
 */
public class Octorock extends Enemies
{
    public static int currentDir = 0;
    public static Projectile p = new Projectile();
    
    /**
     * Act - Holds actions that Octorock will perform each call
     */
    public void act() 
    {
       moveOctorock(); //call to function for random movement
       isHit();
    } //end act()

    /**
     * shoot()
     * octorock randomly shoots a projectile
     * @param dir current direction octorock is facing
     */
    public void shoot(int dir){
            int x=-1,y=-1;
            if(dir == 0){//right
                x = this.getX()+10;
                y = this.getY();
            }
            else if(dir==1){//down
                x = this.getX();
                y = this.getY()+10;
            }
            else if(dir==2){//left
                x = this.getX()-10;
                y = this.getY();
            }
            else if(dir==3){//up
                x = this.getX();
                y = this.getY()-10;
            }
            else if(x == -1 || y ==-1){
                System.out.println("shooting error");
            }
            Octorock.p.alive=true; getWorld().addObject(Octorock.p, x, y);
            
            p.resetShoot(dir);      
    }

    /**
     * Constructor
     * 
     * Records the x and y location of a newly created Octorock
     */
    public Octorock(int x, int y)
    {
        this.alive=true;
        xPose = x;
        yPose = y;
    }
    
    /**
     * moveOctorock - Moves Octorock randomly
     */
    public void moveOctorock(){

        Random generator = new Random(); //random number generator
        int ranNum = generator.nextInt(250); //gets random number from 0-249
        //random shoot
        if(ranNum >200 && ranNum < 203 && !inKnockback){
            shoot(direction);
        }
        if(inKnockback){
            animateHit(direction);
        }
        else{
        //when ranNum 0 rotates Octorock 90 degrees clockwise
        if(ranNum == 0){          
            turn(90);
            direction=direction+1;
            imgRot = imgRot + 90;
            if(direction == 4){ //allows direction to be 0,1,2, or 3 then resets to 0
                direction =0;
                imgRot = 0;
            }
        }
        //when ranNum is 1 rotates Octorock 90 degrees counterclockwise 
        else if(ranNum == 1){
            turn(-90);
            direction=direction-1;
            imgRot = imgRot - 90;
            if(direction == -1){ //allows direction to be 0,1,2 or 3 then resets to 3
                direction = 3;
                imgRot = 270;
            }
        }
        //when ranNum is >2 moves Octorock according to current direction
        else if(ranNum >= 2){
            //Move Octorock down if he won't hit border
            if(UI.dunVal==0 && UI.arenaT!=1) {
                if(direction == 1 && (((LinkWorld) getWorld()).getHeight()-getY())>10 && !UI.colorMaskMap[UI.horizontalScreen][UI.verticalScreen].getColorAt(getX(), getY()+10).equals(Color.black)){
                setImage("OctorockDown0.png"); //loads front facing image
                this.getImage().rotate(270); //rotates image to be oriented correctly
                move(1);
            }
            //Move Moblin left if he won't hit border
            else if(direction == 2 && getX() > 10 && !UI.colorMaskMap[UI.horizontalScreen][UI.verticalScreen].getColorAt(getX()-10, getY()).equals(Color.black)){
                setImage("OctorockLeft0.png"); //loads left facing image
                this.getImage().rotate(imgRot); //rotates image to be oriented correctly
                move(1);
            }
            //Move Moblin up if he won't hit border
            else if(direction == 3 && getY() > 60 && !UI.colorMaskMap[UI.horizontalScreen][UI.verticalScreen].getColorAt(getX(), getY()-10).equals(Color.black)){
                setImage("OctorockUp0.png"); //loads back facing image
                this.getImage().rotate(90); //roates image to be oriented correctly
                move(1); 
            }
            //Move Moblin right if he won't hit border
            else if(direction == 0 && (((LinkWorld) getWorld()).getWidth()-getX())>10 && !UI.colorMaskMap[UI.horizontalScreen][UI.verticalScreen].getColorAt(getX()+10, getY()).equals(Color.black)){
                setImage("OctorockRight0.png"); //loads right facing image
                this.getImage().rotate(imgRot); //rotates image to be oriented correctly
                move(1);
            }
            //Rotate 90 degrees clockwise if current direction will hit border
            else{
                turn(90);
                direction=direction+1;
                currentDir=direction;
                imgRot=imgRot+90;
                if(direction == 4){
                    direction=0;
                    currentDir=0;
                    imgRot=0;
                }
            }  
           
            
        }//end ifDun
         else if(UI.arenaT==1){
             if(direction == 1 && (((LinkWorld) getWorld()).getHeight()-getY())>10 && !UI.arena_mask.getColorAt(getX(), getY()+10).equals(Color.black)){
                 setImage("OctorockDown0.png"); //loads front facing image
                this.getImage().rotate(270); //rotates image to be oriented correctly
                move(1);}
                
             else if(direction == 2 && getX() > 10 && !UI.arena_mask.getColorAt(getX()-10, getY()).equals(Color.black)){
                setImage("OctorockLeft0.png"); //loads left facing image
                this.getImage().rotate(imgRot); //rotates image to be oriented correctly
                move(1);
            }
            
             else if(direction == 3 && getY() > 60 && !UI.arena_mask.getColorAt(getX(), getY()-10).equals(Color.black)){
                setImage("OctorockUp0.png"); //loads back facing image
                this.getImage().rotate(90); //roates image to be oriented correctly
                move(1); 
            }
               else if(direction == 0 && (((LinkWorld) getWorld()).getWidth()-getX())>10 && !UI.arena_mask.getColorAt(getX()+10, getY()).equals(Color.black)){
                setImage("OctorockRight0.png"); //loads right facing image
                this.getImage().rotate(imgRot); //rotates image to be oriented correctly
                move(1);
            }
             else{
                turn(90);
                direction=direction+1;
                imgRot=imgRot+90;
                if(direction == 4){
                    direction=0;
                    imgRot=0;
                }
            }     
            }
            else {
                if(direction == 1 && (((LinkWorld) getWorld()).getHeight()-getY())>10 && !UI.dmasks[UI.dunVal-1].getColorAt(getX(), getY()+10).equals(Color.black)){
                 setImage("OctorockDown0.png"); //loads front facing image
                this.getImage().rotate(270); //rotates image to be oriented correctly
                move(1);}
                
             else if(direction == 2 && getX() > 10 && !UI.dmasks[UI.dunVal-1].getColorAt(getX()-10, getY()).equals(Color.black)){
                setImage("OctorockLeft0.png"); //loads left facing image
                this.getImage().rotate(imgRot); //rotates image to be oriented correctly
                move(1);
            }
            
             else if(direction == 3 && getY() > 60 && !UI.dmasks[UI.dunVal-1].getColorAt(getX(), getY()-10).equals(Color.black)){
                setImage("OctorockUp0.png"); //loads back facing image
                this.getImage().rotate(90); //roates image to be oriented correctly
                move(1); 
            }
               else if(direction == 0 && (((LinkWorld) getWorld()).getWidth()-getX())>10 && !UI.dmasks[UI.dunVal-1].getColorAt(getX()+10, getY()).equals(Color.black)){
                setImage("OctorockRight0.png"); //loads right facing image
                this.getImage().rotate(imgRot); //rotates image to be oriented correctly
                move(1);
            }
             else{
                turn(90);
                direction=direction+1;
                imgRot=imgRot+90;
                if(direction == 4){
                    direction=0;
                    imgRot=0;
                }
            }   
            }}}
        
    } //end moveOctorock()
    
    /**
     * animateHit()
     * @param dir current direction octorock is facing
     * this method is called whenever the enemy has been hit,
     * and does the flashing and knockback animation
     */
    private void animateHit(int dir){
        if(hurtTimer < maxHurtTime){    
            if(hurtDelay == FINAL_DELAY){
                if(isHurt){
                    switch(dir){
                        case 1:
                        setImage("images/OctorockHurtDown0.png"); //loads front facing image
                        this.getImage().rotate(270); //rotates image to be oriented correctly
                        break;
                
                        case 2:
                        setImage("images/OctorockHurtLeft0.png"); //loads left facing image
                        this.getImage().rotate(imgRot); //rotates image to be oriented correctly
                        break;
                        case 3:
                        setImage("images/OctorockHurtUp0.png"); //loads back facing image
                        this.getImage().rotate(90); //roates image to be oriented correctly
                        break;
                        case 0:
                        setImage("images/OctorockHurtRight0.png"); //loads right facing image
                        this.getImage().rotate(imgRot); //rotates image to be oriented correctly
                        break;
                    }
                    if(!UI.colorMaskMap[UI.horizontalScreen][UI.verticalScreen].getColorAt(getX(), getY()+10).equals(Color.black)){
                        move(-1);
                    }
                    isHurt=false;
                }
                else if(!isHurt){
                    switch(dir){
                        case 1:
                        setImage("images/OctorockDown0.png"); //loads front facing image
                        this.getImage().rotate(270); //rotates image to be oriented correctly
                        break;
                
                        case 2:
                        setImage("images/OctorockLeft0.png"); //loads left facing image
                        this.getImage().rotate(imgRot); //rotates image to be oriented correctly
                        break;
                        case 3:
                        setImage("images/OctorockUp0.png"); //loads back facing image
                        this.getImage().rotate(90); //roates image to be oriented correctly
                        break;
                        case 0:
                        setImage("images/OctorockRight0.png"); //loads right facing image
                        this.getImage().rotate(imgRot); //rotates image to be oriented correctly
                        break;
                    }
                    if(!UI.colorMaskMap[UI.horizontalScreen][UI.verticalScreen].getColorAt(getX(), getY()+10).equals(Color.black)){
                        move(-1);
                    }
                    isHurt=true;
                }
                hurtDelay=0;
            }
            else{
                hurtDelay++;
            }
            hurtTimer++;
        }
        else{
            inKnockback=false;
            takeHealth=true; //state to be damaged
        }
    }//end animateHit
} //end Octorock class
 