import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;
/**
 * This is the projectile fired by the Octorock enemy
 * 
 * @author Alex Fielder
 * @version 5/10/2012
 */
public class Projectile extends UI
{

    public static int animate=0;
    private static final int shootLength=100;
    private static int currShoot=shootLength;
    private int direction=0;
    private int imgRot=0;
    public boolean alive=true;
    private boolean finish=false;
    private boolean turn=false;
    /**
     * Act - do whatever the Projectile wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        shoot();
    }
    /**
     * shoot()
     * Move projectile across the screen in a certain direction
     */
    public void shoot(){
        if(currShoot <= shootLength){
            if(direction == 0 && !turn){
                turn=true;
            }
            else if(direction ==1 && !turn){
                imgRot=90;
                turn(imgRot);
                turn=true;
            }
            else if(direction ==2 && !turn){
                imgRot = 180;
                turn(imgRot);
                turn=true;
            }
            else if(direction ==3 && !turn){
                imgRot=-90;
                turn(imgRot);
                turn=true;
            }
            //collision detection with Link
            Actor link = getOneIntersectingObject(Link.class);
            if(link != null){
                Link.linkIsHit();
                //getWorld().removeObject(this);
                finish=false;
                turn=false;
                //reset image back to original rotation angle
                turn(-imgRot);
                imgRot=0;
            }
            //collision with wall
            if(UI.dunVal==0 && UI.arenaT==0){
            if(UI.colorMaskMap[UI.horizontalScreen][UI.verticalScreen].getColorAt(getX(), getY()+10).equals(Color.black)){

                
                finish=false;
                turn=false;
                //reset image back to original rotation angle
                turn(-imgRot);
                imgRot=0;
                if( this.isAlive()==true)this.destroy();
                
            }}
            else if(UI.dunVal!=0){
                if(UI.dmasks[UI.dunVal-1].getColorAt(getX(), getY()+10).equals(Color.black)){

                
                finish=false;
                turn=false;
                //reset image back to original rotation angle
                turn(-imgRot);
                imgRot=0;
                
                if( this.isAlive()==true)this.destroy();
                
            }}
            else if(UI.arenaT==1){
                if(UI.arena_mask.getColorAt(getX(), getY()+10).equals(Color.black)){

                
                finish=false;
                turn=false;
                //reset image back to original rotation angle
                turn(-imgRot);
                imgRot=0;
                if( this.isAlive()==true)this.destroy();
                
            }}
            
            
            move(2);
            if(animate==0){
                setImage("fireball2.png");
                animate=1;}
                else{ setImage("fireball.png"); animate=0;}
            currShoot++;
        }
        else{
            
            finish=false;
            turn=false;
            //reset image back to original rotation angle
            turn(-imgRot);
            imgRot=0;
            getWorld().removeObject(this);
        }
    }
    /**
     * removeSelf()
     * remove projectile from the world
     */
     public void removeSelf()
    {
        this.getWorld().removeObject(this);
    }
    
    /**
     * Sets alive boolean to false, and removes the projectile from the world.
     */
    protected void destroy()
    {
        alive = false;
        removeSelf();
    }
    
    /**
     * Returns a boolean based on whether the projectile is still alive or not.
     */
    protected boolean isAlive()
    {
        return this.alive;
    }
    
    /**
     * resetShoot()
     * this method resets the variables which allow the animation of the shoot to start
     * @param dir -  current direction the octorock is facing
     */
    public void resetShoot(int dir){
        if(currShoot < shootLength){ return;}
        if(!finish){
            direction = dir;
            finish=true;
        }
        currShoot=0;
    }
}
