import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class UI here.
 * 
 * @author Team Link
 * @version 5/10/2012
 * This class contains all the images and image arrays that will be used to 
 * display the overworld and the dungeons
 */
public class UI  extends Actor
{
    /**
     * All user interface variables are declared here. All are named according to what they actually
     * do, due to convenience.
     */
    public static GreenfootImage visualScreen1 = new GreenfootImage("Visual/Screen1.png");
    public static GreenfootImage visualScreen2 = new GreenfootImage("Visual/Screen2.png");
    public static GreenfootImage visualScreen3 = new GreenfootImage("Visual/Screen3.png");
    public static GreenfootImage visualScreen4 = new GreenfootImage("Visual/Screen4.png");
    
    public static GreenfootImage colorMaskScreen1 = new GreenfootImage("OverworldMask/ColorMaskScreen1.png");
    public static GreenfootImage colorMaskScreen2 = new GreenfootImage("OverworldMask/ColorMaskScreen2.png");
    public static GreenfootImage colorMaskScreen3 = new GreenfootImage("OverworldMask/ColorMaskScreen3.png");
    public static GreenfootImage colorMaskScreen4 = new GreenfootImage("OverworldMask/ColorMaskScreen4.png");
    
    public static GreenfootImage d1 = new GreenfootImage("Dungeon_1/Dungeon1_1.png");
    public static GreenfootImage d2 = new GreenfootImage("Dungeon_1/Dungeon1_2.png");
    public static GreenfootImage d3 = new GreenfootImage("Dungeon_1/Dungeon1_3.png");
    public static GreenfootImage d4 = new GreenfootImage("Dungeon_1/Dungeon1_4.png");
    public static GreenfootImage d5 = new GreenfootImage("Dungeon_1/Dungeon1_5.png");
    public static GreenfootImage d6 = new GreenfootImage("Dungeon_1/Dungeon1_6.png");
    public static GreenfootImage d7 = new GreenfootImage("Dungeon_1/Dungeon1_7.png");
    public static GreenfootImage d8 = new GreenfootImage("Dungeon_1/Dungeon1_8.png");
    public static GreenfootImage d9 = new GreenfootImage("Dungeon_1/Dungeon1_9.png");
    public static GreenfootImage d10 = new GreenfootImage("Dungeon_1/DungeonFinal.png");
    public static GreenfootImage s1 = new GreenfootImage("Dungeon_1/Secret1.png");
    public static GreenfootImage s2 = new GreenfootImage("Visual/River.png");
    
    public static GreenfootImage smask2 = new GreenfootImage("OverworldMask/ColorMaskRiver.png");
    public static GreenfootImage dmask1 = new GreenfootImage("Dungeon_1/Dungeon1_1Mask.png");
    public static GreenfootImage dmask2 = new GreenfootImage("Dungeon_1/Dungeon1_2Mask.png");
    public static GreenfootImage dmask3 = new GreenfootImage("Dungeon_1/Dungeon1_3Mask.png");
    public static GreenfootImage dmask4 = new GreenfootImage("Dungeon_1/Dungeon1_4Mask.png");
    public static GreenfootImage dmask5 = new GreenfootImage("Dungeon_1/Dungeon1_5Mask.png");
    public static GreenfootImage dmask6 = new GreenfootImage("Dungeon_1/Dungeon1_6Mask.png");
    public static GreenfootImage dmask7 = new GreenfootImage("Dungeon_1/Dungeon1_7Mask.png");
    public static GreenfootImage dmask8 = new GreenfootImage("Dungeon_1/Dungeon1_8Mask.png");
    public static GreenfootImage dmask9 = new GreenfootImage("Dungeon_1/Dungeon1_9Mask.png");
    public static GreenfootImage dmask10 = new GreenfootImage("Dungeon_1/DungeonFinalMask.png");
    public static GreenfootImage smask1 = new GreenfootImage("Dungeon_1/Secret1Mask.png");
    
    public static GreenfootImage[] dmasks = { dmask1, dmask2, dmask3, dmask4, dmask5, dmask6, dmask7, dmask8, dmask9, dmask10, smask1 };
    public static GreenfootImage[] dlevel = { d1, d2, d3, d4, d5, d6, d7, d8, d9, d10, s1 };
    
    
    public static GreenfootImage arena = new GreenfootImage("Dungeon_1/Dungeon_plain.png");
    public static GreenfootImage arena_mask = new GreenfootImage("Dungeon_1/Dungeon_plain_mask.png");
    
    public static int arenaT=0;
    public static int trigger9=0;
    public static int trigger8=0;
    public static int bossWarp=0;
    public static GreenfootImage bar = new GreenfootImage("UIBar.png");
    public static int dunVal=0;
    public static int miniBoss=0;
    public static int trigger6=0;
    //252x169
    //756 is 252*3, 657 is 219*3
    public static GreenfootImage tempBg = new GreenfootImage(756, 657);
    
    /**
     * The variables for all the music and sound files in the game.
     */
    public static GreenfootSound bossDown = new GreenfootSound("Triforce.mp3");
    public static GreenfootSound music = new GreenfootSound("overworld.mp3");
    public static GreenfootSound gameOverSFX = new GreenfootSound("LOZ_Die.wav");
    public static GreenfootSound correct = new GreenfootSound("smrpg_correct.wav");
    public static GreenfootSound wrong= new GreenfootSound("smrpg_wrong.wav");
    public static GreenfootSound swing= new GreenfootSound("LOZ_Sword.wav");
    public static GreenfootSound hurt= new GreenfootSound("LOZ_Hurt.wav");
    public static GreenfootSound hit= new GreenfootSound("LOZ_Hit.wav");
    public static GreenfootSound kill= new GreenfootSound("LOZ_Kill.wav");
    public static GreenfootSound secret= new GreenfootSound("LOZ_Secret.wav");
    public static GreenfootSound enter= new GreenfootSound("LOZ_Stairs.wav");
    public static GreenfootSound warp= new GreenfootSound("smrpg_battle_vigorup.wav");
    public static GreenfootSound dunMusic1= new GreenfootSound("SkyrimTest.mp3");
    public static GreenfootSound dunMusic2= new GreenfootSound("Dungeon2.mp3");
    public static GreenfootSound endGame = new GreenfootSound("Ending_Theme.mp3");
    public static GreenfootImage[][] colorMaskMap = 
    {
        {colorMaskScreen1, colorMaskScreen4},
        {colorMaskScreen2, colorMaskScreen3}        
    };
    
    public static GreenfootImage[][] visualMap = 
    {
        {visualScreen1, visualScreen4},
        {visualScreen2, visualScreen3}  
    };
    public static int colorMaskLength = 2;
    public static int visualMapLength = 2;
    
    //This variable is used to determine which screen Link is currently on
    public static int horizontalScreen = 0;
    public static int verticalScreen = 0;
    
    public void spawnTrap(){
        //not implemented yet
    }
}
