import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This class adds the same objects when link is in the arena secret
 * 
 * @author Alex Fielder 
 * @version May 2012
 */
public class arenaSpawner extends Enemies  
{
    static final int FINAL_ROUNDS=3;
    Octorock o1 = new Octorock(60,170);
    Octorock o2 = new Octorock(60,100);
    Octorock o3 = new Octorock(200,85);

    Moblin m1 = new Moblin(60,160);
    Moblin m2 = new Moblin(60,90);
    Moblin m3 = new Moblin(200,75);
    private boolean init=true;
    private boolean arenaOver=false;
    private int round =1;
    //public Link link2= getWorld().link;
  
    /**
     * Act - do whatever the arenaSpawner wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act(){
        arenaSpawn();
        
        //System.out.println(linkX);
    }
    
    /**
     * Adds the enemies to the arena based off of the param
     * @param r
     *      Number of enemies added
     */
    public void addEnemies(int r){
        
        if(round>1){
            o1.resetEnemy();
            o2.resetEnemy();
            o3.resetEnemy();

            m1.resetEnemy();
            m2.resetEnemy();
            m3.resetEnemy();
        }
        getWorld().addObject(o1,60,170);
        //getWorld().addObject(o2,60,100);
        //getWorld().addObject(o3,200,85);

        getWorld().addObject(m1,60,160);
        //getWorld().addObject(m2,60,90);
        //getWorld().addObject(m3,200,75);
    }
    
    /**
     * Is the general spawner for the enemies in the arena. This is completely seperate from the 
     * enemies spawned by the Spawner class.
     */
    public void arenaSpawn(){
        if(init){
            addEnemies(round);
            init=false;
        }
        if(!arenaOver && !init){
            //proceed to next round if all enemies are dead
            if( round < FINAL_ROUNDS && !o1.alive /*&& !o2.alive && !o3.alive */
                                    && !m1.alive/* && !m2.alive && !m3.alive*/){

                round++;
                addEnemies(round);
            }
            //end arena
            else if (round>= FINAL_ROUNDS){
                arenaOver=true;//all enemies defeated
            }

        }//end of:: if !arenaOver
        else if(arenaOver){

            o1.destroy();
            //o2.destroy();
            //o3.destroy();
            m1.destroy();
            //m2.destroy();
            //m3.destroy();
           UI.arenaT=2;
           UI.dunMusic1.stop();
           
           UI.secret.play();
                   getWorld().addObject(LinkWorld.heart2, 201, 34);
                   getWorld().addObject(LinkWorld.heart3, 211, 34);
                   getWorld().addObject(LinkWorld.heart4, 221, 34);
                   getWorld().addObject(LinkWorld.heart5, 231, 34);
                   Link.health=Link.health+4;
           UI.horizontalScreen=0;
           UI.verticalScreen=1;
           //Link.setLocation(50,100);
           UI.tempBg.drawImage(UI.colorMaskMap[UI.horizontalScreen][UI.verticalScreen],0,0);
           UI.tempBg.drawImage(UI.visualMap[UI.horizontalScreen][UI.verticalScreen],0,50);
           getWorld().removeObject(this);
           UI.music.playLoop();
        }
    }//end of arenaSpawn()
}
